# Ecosystem
InversifyJS is a tiny library, but its contracts and APIs are carefully chosen to spawn an ecosystem of tools and extensions.

On this page we will only feature a few of them that the InversifyJS maintainers have vetted personally. 
Don’t let this discourage you from trying the rest of them!
Consider these the “staff picks”, and don’t hesitate to submit a PR if you’ve built something wonderful with InversifyJS.

### Utilitites
- [inversify-binding-decorators](https://github.com/inversify/inversify-binding-decorators) - Allows developers to declare lazy evaluated property injection using decorators.
- [inversify-inject-decorators](https://github.com/inversify/inversify-inject-decorators) - Allows developers to declare InversifyJS bindings using decorators.
- [inversify-express-utils](https://github.com/inversify/inversify-express-utils) - Some utilities for the development of express application with Express.
- [inversify-restify-utils](https://github.com/inversify/inversify-restify-utils) - Some utilities for the development of express application with Restify.

### Extensions
- [inversify-logger-middleware](https://github.com/inversify/inversify-logger-middleware) - A console logger middleware for InversifyJS.

### Development tools
- [inversify-devtools](https://github.com/inversify/inversify-devtools) - A web application that powers the browser extensions.
- [inversify-chrome-devtools](https://github.com/inversify/inversify-chrome-devtools) - A chrome extension that aims to help developers working with InversifyJS.

### Examples
- [Express](https://github.com/inversify/inversify-express-example)
- [Hapi](https://github.com/inversify/inversify-hapi-example)
- [InversifyJS Binding Decorators](https://github.com/inversify/inversify-express-example/tree/master/BindingDecorators)
- [Marionette](https://github.com/inversify/inversify-marionette-example)

### Open Source Projects using InversifyJS
- [Dwatch](https://github.com/Mercateo/dwatch) - Manage your docker containers, images and networks in a nice and clean way.
- [Retax](https://github.com/retaxJS) - Universal React Redux Framework.
- [Demgel-mvc](https://github.com/DemgelOpenSource/demgel-mvc) - MVC framework using express and inversify.
- [Prettygoat](https://www.npmjs.com/package/prettygoat) - The not so baaaaaaad Event Sourcing Projection Engine.
- [Ninjagoat](https://www.npmjs.com/package/ninjagoat) - The not so baaaaaaad MVVM framework.
- [Rokot](https://github.com/Rocketmakers/rokot) Rocketmakers Node-Typescript Platform.
- [Homenet Core](https://github.com/denwilliams/homenet-core) - Homenet home automation.
