# Wiki
Welcome to the InversifyJS wiki!

### The InversifyJS Features and API
- [Support for classes](https://github.com/inversify/InversifyJS/blob/master/wiki/classes_as_id.md)
- [Support for Symbols](https://github.com/inversify/InversifyJS/blob/master/wiki/symbols_as_id.md)
- [Declaring kernel modules](https://github.com/inversify/InversifyJS/blob/master/wiki/kernel_modules.md)
- [Kernel snapshots](https://github.com/inversify/InversifyJS/blob/master/wiki/kernel_snapshots.md)
- [Controlling the scope of the dependencies](https://github.com/inversify/InversifyJS/blob/master/wiki/scope.md)
- [Injecting a constant or dynamic value](https://github.com/inversify/InversifyJS/blob/master/wiki/value_injection.md)
- [Injecting a class constructor](https://github.com/inversify/InversifyJS/blob/master/wiki/constructor_injection.md)
- [Injecting a Factory](https://github.com/inversify/InversifyJS/blob/master/wiki/factory_injection.md)
- [Auto factory](https://github.com/inversify/InversifyJS/blob/master/wiki/auto_factory.md)
- [Injecting a Provider (asynchronous Factory)](https://github.com/inversify/InversifyJS/blob/master/wiki/provider_injection.md)
- [Activation handler](https://github.com/inversify/InversifyJS/blob/master/wiki/activation_handler.md)
- [Middleware](https://github.com/inversify/InversifyJS/blob/master/wiki/middleware.md)
- [Multi-injection](https://github.com/inversify/InversifyJS/blob/master/wiki/multi_injection.md)
- [Tagged bindings](https://github.com/inversify/InversifyJS/blob/master/wiki/tagged_bindings.md)
- [Create your own tag decorators](https://github.com/inversify/InversifyJS/blob/master/wiki/custom_tag_decorators.md)
- [Named bindings](https://github.com/inversify/InversifyJS/blob/master/wiki/named_bindings.md)
- [Kernel.getAll<T>(), Kernel.getNamed<T>() & Kernel.getTagged<T>()](https://github.com/inversify/InversifyJS/blob/master/wiki/get_all_named_tagged.md)
- [Support for hierarchical DI systems](https://github.com/inversify/InversifyJS/blob/master/wiki/hierarchical_di.md)
- [Contextual bindings & @targetName](https://github.com/inversify/InversifyJS/blob/master/wiki/contextual_bindings.md)
- [Property injection](https://github.com/inversify/InversifyJS/blob/master/wiki/property_injection.md)
- [Circular dependencies](https://github.com/inversify/InversifyJS/blob/master/wiki/circular_dependencies.md)
- [Inheritance](https://github.com/inversify/InversifyJS/blob/master/wiki/inheritance.md)

### Other documents
- [Why InversifyJS?](https://github.com/inversify/InversifyJS/blob/master/wiki/purpose.md)
- [Environment support and polyfills](https://github.com/inversify/InversifyJS/blob/master/wiki/environment.md)
- [Vanilla JavaScript example](https://github.com/inversify/InversifyJS/blob/master/wiki/basic_js_example.md)
- [Working with module bundlers](https://github.com/inversify/InversifyJS/blob/master/wiki/module_bundlers.md)
- [ES5 and ES6 support](https://github.com/inversify/InversifyJS/blob/master/wiki/javascript.md)
- [Object-oriented design](https://github.com/inversify/InversifyJS/blob/master/wiki/oo_design.md)
- [Good practices](https://github.com/inversify/InversifyJS/blob/master/wiki/good_practices.md)
- [How to upgrade from 1.x to 2.x](https://github.com/inversify/InversifyJS/blob/master/wiki/upgrade.md)
- [Ecosystem](https://github.com/inversify/InversifyJS/blob/master/wiki/ecosystem.md)
- [Recipes](https://github.com/inversify/InversifyJS/blob/master/wiki/recipes.md)
- [Architecture overview](https://github.com/inversify/InversifyJS/blob/master/wiki/architecture.md)
- [Glossary](https://github.com/inversify/InversifyJS/blob/master/wiki/glossary.md)
